//
//
//

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
//#include <g++/Integer.h>
#include <unistd.h>
#include <signal.h>

#include "xvm.h"
#include "xvmsupport.h"
//#include "xvmserver.h"
#include "xvmconfig.h"

#define XVM_VER_SERVER "0.0.18"

xvmqueue mbuf;
Xvm *XVMashine;
int ServerStatus;
int tempint;
char tempcharbuf[MAX_XQ_MTEXT_LEN];
char *tempstr=tempcharbuf;
int delay=1;
int userbreak=0;
pid_t parent=0;
pid_t child=0;

char* GetAbout();
char* GetVersion();

void usrbreak(int sig){
	sig=0;
	userbreak=1;
};

/*void childcrsh(int sig){
	sig=0;
	signal(SIGCHLD,childcrsh);
};*/

int 
ProcessMessage(){
	switch(mbuf.msubtype){
		case XQ_ST_NOP:
		break;
		case XQ_ST_COM:
			switch(mbuf.mtext[0]){
				case XQ_TCOM_INIT:
					SendMessage(XQ_ST_INF,"XVMashine initialised.\n");
					XVMashine->InitProg(1);
				break;
				case XQ_TCOM_STEP:
					strcpy(tempstr,"Step Mode.\nCommand =\t");
					strcat(tempstr,ItoA(XVMashine->GetCurCommNo()));
					strcat(tempstr,"\n");
					SendMessage(XQ_ST_INF,tempstr);
					XVMashine->StepProg();
					switch(XVMashine->GetProgStatus()){
						case XVM_STOPED:
							strcpy(tempstr,"Stoped at =\t");
							strcat(tempstr,ItoA(XVMashine->GetCurCommNo()));
							strcat(tempstr,"\n");
							SendMessage(XQ_ST_INF,tempstr);
						break;
						case XVM_ERRORSTOP:
							strcpy(tempstr,"Stoped on ERROR at =\t");
							strcat(tempstr,ItoA(XVMashine->GetCurCommNo()));
							strcat(tempstr,"\n");
							SendMessage(XQ_ST_INF,tempstr);
						break;
						case XVM_EXECUTING:
							strcpy(tempstr,"Step OK.\n");
							SendMessage(XQ_ST_INF,tempstr);
						break;
					};
					XVMashine->SyncRegs();
				break;
				case XQ_TCOM_EXEC:
					SendMessage(XQ_ST_INF,"Executing...\n");
					SendMessage(XQ_ST_BUSY);
					signal(SIGUSR1,usrbreak);
					userbreak=0;
					parent=0;
					child=0;
					if((child=fork())==0){
						parent=getppid();
						//delete XVMashine;
						while(!userbreak){
							if((tempint=WaitMessage(&mbuf))==1 && (mbuf.msubtype==XQ_ST_COM && 
									mbuf.mtext[0]==XQ_TCOM_BREAK)){
								kill(parent,SIGUSR1);
							}
							else{
								if(tempint==1){
									SendMessage(XQ_ST_INF,"Server BUSY, try later.\n");
								};
							};
						};
						exit(0);
					};
					while(XVMashine->GetProgStatus()==XVM_EXECUTING && userbreak==0){
						XVMashine->StepProg();
					};
					if(userbreak){
						XVMashine->StopProg(XVM_USERBREAK);
					};
					kill(child,SIGUSR1);
					signal(SIGUSR1,SIG_DFL);
					switch(XVMashine->GetProgStatus()){
						case XVM_STOPED:
							strcpy(tempstr,"Stoped at =\t");
							strcat(tempstr,ItoA(XVMashine->GetCurCommNo()));
							strcat(tempstr,"\n");
							SendMessage(XQ_ST_INF,tempstr);
						break;
						case XVM_USERBREAK:
							strcpy(tempstr,"Break by user at =\t");
							strcat(tempstr,ItoA(XVMashine->GetCurCommNo()));
							strcat(tempstr,"\n");
							SendMessage(XQ_ST_INF,tempstr);
						break;
						case XVM_ERRORSTOP:
							strcpy(tempstr,"Stoped on ERROR at =\t");
							strcat(tempstr,ItoA(XVMashine->GetCurCommNo()));
							strcat(tempstr,"\n");
							SendMessage(XQ_ST_INF,tempstr);
						break;
						default:
						break;
					};
					SendMessage(XQ_ST_NOBUSY);
				break;
				case XQ_TCOM_QUIT:
					ServerStatus=0;
				break;
				default:
				break;
			};
		break;
		case XQ_ST_SET_REG:
			XVMashine->SetReg(mbuf.mno,mbuf.mtext);
			XVMashine->SetNCDReg(mbuf.mno,atol(mbuf.mtext));
		break;
		case XQ_ST_SET_COMM:
			XVMashine->SetComm(mbuf.mno,mbuf.mtext);
		break;
		case XQ_ST_GET_REG:
			SendMessage(XQ_ST_GET_REG,XVMashine->GetReg(mbuf.mno));
		break;
		case XQ_ST_GET_COMM:
			SendMessage(XQ_ST_GET_COMM,XVMashine->GetComm(mbuf.mno));
		break;
		case XQ_ST_GET_COMMENT:
			SendMessage(XQ_ST_GET_COMMENT,XVMashine->GetComment(mbuf.mno));
		break;	
		case XQ_ST_SET_COMMENT:
			XVMashine->SetComment(mbuf.mno,mbuf.mtext);
		break;
		case XQ_ST_GET_ERROR:
			SendMessage(XQ_ST_GET_ERROR,XVMashine->GetError());
		break;
		case XQ_ST_SAVE:
			SendMessage(XQ_ST_INF,"Saving...\n");
			if(PrepareSave(mbuf.mtext,0,XVMashine)==-1){
				SendMessage(XQ_ST_INF,"Can`t save.\n");
			}
			else{
				SaveXVMStatus();
				SendMessage(XQ_ST_INF,"Save OK.\n");
			};
		break;
		case XQ_ST_LOAD:
			SendMessage(XQ_ST_INF,"Loading...\n");
			if(PrepareLoad(mbuf.mtext,0,XVMashine)==-1){
				SendMessage(XQ_ST_INF,"Can`t load.\n");
			}
			else{
				LoadXVMStatus();
				SendMessage(XQ_ST_INF,"Load OK.\n");
			};
		break;
		case XQ_ST_GET_CURCOMMNO:
			SendMessage(XQ_ST_GET_CURCOMMNO,"",XVMashine->GetCurCommNo());
		break;
		case XQ_ST_GET_PREVCOMMNO:
			SendMessage(XQ_ST_GET_PREVCOMMNO,"",XVMashine->GetPrevCommNo());
		break;
		case XQ_ST_GET_PROGSTATUS:
			SendMessage(XQ_ST_GET_PROGSTATUS,"",XVMashine->GetProgStatus());
		break;
		case XQ_ST_GET_SERVERSTATUS:
			SendMessage(XQ_ST_GET_SERVERSTATUS,"",ServerStatus);
		break;
		case XQ_ST_GET_XVMABOUT:
			SendMessage(XQ_ST_GET_XVMABOUT,XVMashine->GetAbout());
		break;
		case XQ_ST_GET_SUPPORTABOUT:
			SendMessage(XQ_ST_GET_SUPPORTABOUT,GetAboutSupport());
		break;
		case XQ_ST_GET_SERVERABOUT:
			SendMessage(XQ_ST_GET_SERVERABOUT,GetAbout());
		break;
		case XQ_ST_GET_XVMVER:
			SendMessage(XQ_ST_GET_XVMVER,XVMashine->GetVersion());
		break;
		case XQ_ST_GET_SUPPORTVER:
			SendMessage(XQ_ST_GET_SUPPORTVER,GetVersionSupport());
		break;
		case XQ_ST_GET_SERVERVER:
			SendMessage(XQ_ST_GET_SERVERVER,GetVersion());
		break;
		case XQ_ST_NODELAY:
			delay=0;
		break;
		case XQ_ST_DELAY:
			delay=1;
		break;
		case XQ_ST_GET_REGLIST:
			for(tempint=mbuf.mno;tempint<=mbuf.mres;tempint++){
				SendMessage(XQ_ST_GET_REGLIST,
					XVMashine->GetReg(tempint),tempint);
			};
		break;
		case XQ_ST_GET_COMMLIST:
			for(tempint=mbuf.mno;tempint<=mbuf.mres;tempint++){
				SendMessage(XQ_ST_GET_COMMLIST,
					XVMashine->GetComm(tempint),tempint);
			};
		break;
		case XQ_ST_GET_COMMENTLIST:
			for(tempint=mbuf.mno;tempint<=mbuf.mres;tempint++){
				SendMessage(XQ_ST_GET_COMMENTLIST,
					XVMashine->GetComment(tempint),tempint);
			};
		break;
		default:
		break;
	};
	return 1;
};

char*
GetVersion(){
	return XVM_VER_SERVER;
};

char*
GetAbout(){
	char* buf;
	buf=new char[MAX_XVM_COMMENT_LEN];
	strcpy(buf,"XVM Server, ver: ");
	strcat(buf,GetVersion());
	strcat(buf," . Copyright(c) 1998, 1999 Dmitry Morozhnikov.\n");
	return buf;
	delete buf;	
};

int 
main(){
	int mst;
	signal(SIGCHLD,SIG_IGN);
	if(InitQueue()==-1){
		exit(1);
	};
	ServerStatus=1;
	SendMessage(XQ_ST_INF,GetAbout());
	XVMashine=new Xvm;
 	SendMessage(XQ_ST_INF,"Server initialised with...\n");
 	SendMessage(XQ_ST_INF,XVMashine->GetAbout());
 	SendMessage(XQ_ST_INF,"Use support library...\n");
 	SendMessage(XQ_ST_INF,GetAboutSupport());
	delay=1;
 	while((ServerStatus>0) && (GetQueueStatus()==XQ_ON)){
 		mst=WaitMessage(&mbuf);
		if(mst==1){
			ProcessMessage();
		};
 	};
 	SendMessage(XQ_ST_INF,"XVM server going done.\n");
 	sleep(2);
 	DeleteQueue();
 	delete XVMashine;
	exit(0);
};
 
 	
 		
